package com.getsnappy.snappyj;

import java.io.IOException;
import java.io.Writer;

import com.sun.org.apache.xpath.internal.functions.Function;

/**
 * This loading indicator  will apply the opaque png "/images/grey.png" screenwide and
 * then load /images/loadingBox.png and attempt to keep it centered in the screen
 *
 * @author brian
 *
 */
public class BlockingAnimatedGifLoadingIndicator extends JavaScriptLoadingIndicator {
   private static BlockingAnimatedGifLoadingIndicator indicator;
   
   /**
    * Load the single shared instance.
    * @return
    */
   public static BlockingAnimatedGifLoadingIndicator getInstance() { 
      
      if (indicator == null) { 
         indicator = new BlockingAnimatedGifLoadingIndicator();
         
      }
      return indicator;
   }
   /**
    * This function will apply the opaque png "/images/grey.png" screenwide and
    * then load /images/loadingBox.png and attempt to keep centered in the screen
    * 
    * @throws IOException 
    */
   @Override
   public void jsStart(Writer out) throws IOException {
      
      out.write("function () {\n");
      out.write("var grey;\n");
      out.write("grey = document.getElementById('grey');\n");


      out.write("var scroll = getScrollXY();\n");
      out.write("var windowSize = getWindowSize();\n");
      out.write("if (grey == undefined) {\n");
      out.write("   var grey = document.createElement('div');\n");
      out.write("   grey.style.position = 'absolute';\n");
      out.write("   grey.style.top = scroll[1] + 'px';\n");
      out.write("   grey.style.left = scroll[0] + 'px';\n");
      out.write("   grey.style.background = 'url(/images/grey.png) repeat';\n");
      out.write("   grey.id = 'grey';");
      out.write("   grey.style.width = windowSize[0] + 'px';\n");
      out.write("   grey.style.height = windowSize[1] + 'px';\n");

      out.write("    var loadingBox = document.createElement('div');\n");
      out.write("   loadingBox.style.position = 'relative';\n");
      out.write("   loadingBox.style.left = ((windowSize[0] - 120) / 2) + 'px' ;\n");
      out.write("   loadingBox.style.top = ((windowSize[1] - 125) / 2) + 'px';\n");
      out.write("   loadingBox.style.background = 'url(/images/loadingBox.png) no-repeat';\n");
      out.write("   loadingBox.style.width='120px';\n");
      out.write("   loadingBox.style.height='125px';\n");

      out.write("   var animatedLoading = document.createElement(\"div\");\n");
      out.write("   animatedLoading.style.position = 'relative';\n");
      out.write("   animatedLoading.style.top = '10px';\n");
      out.write("   animatedLoading.style.left = '10px';\n");
      out.write("   animatedLoading.style.background = 'url(/images/animatedLoading.gif) no-repeat';\n");
      out.write("   animatedLoading.style.width='100px'; \n");
      out.write("   animatedLoading.style.height='100px';\n");

      out.write("   loadingBox.appendChild(animatedLoading);\n");

      out.write("   grey.appendChild(loadingBox);\n");
         
         
      out.write("   if(window.addEventListener)\n");
      out.write("   {\n");
      out.write("      window.addEventListener(\"scroll\", grey_ref, false);\n");
      out.write("   }\n");
      out.write("   else if(document.addEventListener) // Opera 7+\n");
      out.write("   {\n");
      out.write("      document.addEventListener(\"scroll\", grey_ref, false);\n");
      out.write("   }\n");
      out.write("   else if(document.all && document.compatMode && document.compatMode == 'CSS1Compat')\n");
      out.write("   {\n");
      out.write("      if('onscroll' in self)\n");
      out.write("      {\n");
      out.write("         window.onscroll = grey_ref;\n");
      out.write("      };\n");
      out.write("   };\n");
         
      out.write("   document.body.appendChild(grey);\n");
            
      out.write("} else {\n");
      out.write("   grey.style.top = scroll[1] + 'px';\n");
      out.write("   grey.style.left = scroll[0] + 'px';\n");
      out.write("   grey.style.width = windowSize[0] + 'px';\n");
      out.write("   grey.style.height = windowSize[1] + 'px';\n");
      out.write("}\n");
      out.write("}\n");
   }
   
   @Override
   public void jsFinish(Writer out) throws IOException {
      out.write("function () {\n");
      out.write("   var grey = document.getElementById('grey');\n");
      out.write("   if (grey != undefined) {\n");
      out.write("      document.body.removeChild(grey);\n");
      out.write("      if(window.addEventListener)\n");
      out.write("      {\n");
      out.write("         window.removeEventListener('scroll', grey_ref, false);\n");
      out.write("      }\n");
      out.write("      else if(document.addEventListener) // Opera 7+\n");
      out.write("      {\n");
      out.write("         document.removeEventListener('scroll', grey_ref, false);\n");
      out.write("      }\n");
      out.write("      else if(document.all && document.compatMode && document.compatMode == 'CSS1Compat')\n");
      out.write("      {\n");
      out.write("         if('onscroll' in self)\n");
      out.write("         {\n");
      out.write("            window.onscroll = undefined;\n");
      out.write("         }\n");
      out.write("      }\n");
      out.write("   }\n");
      out.write("}\n");
   }
}
