package com.getsnappy.snappyj;

import java.io.Writer;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * The DefaultMessageapplicationErrorHandler simply outputs a
 * generic message to out.  For example when used with the default constructor 
 * the following code is execute by handleException
 * out.write("An Error has Occured!");
 * 
 * @author brian
 * @see ApplicationInstance
 */
public class DefaultMessageApplicationErrorHandler implements ApplicationErrorHandler{
   String defaultMessage;
   
   /**
    * Sets the defaultMessage to "An Error has Occured!"
    */
   public DefaultMessageApplicationErrorHandler() {
      defaultMessage = "An Error has Occured!";
      
   }
   
   /**
    * Sets the defaultMessage to the param defaultMessage.
    * 
    * @param defaultMessage
    */
   public DefaultMessageApplicationErrorHandler(String defaultMessage) {
      this.defaultMessage = defaultMessage;
   }
   /**
    * This error handler simply prints out defaultMessage
    * 
    * @param out is not used in this implementation
    * @param request is not used in this implementation
    * @param response is not used in this implementation
    * @throws Exception always re-throw e out unmodified
    */
   public void handleException(Exception e,Writer out,HttpServletRequest request,HttpServletResponse response) throws Exception {
      throw e;
   }

}
