package com.getsnappy.snappyj;

import java.io.IOException;
import java.io.Writer;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * FIXME: document me!!!!
 * 
 * @author brian
 *
 */
public abstract class DynamicContext extends Context {
   String contextId;
   DynamicContextBean dynamicContextBean;
   JavaScriptLoadingIndicator indicator = null;
   
   
   /**
    * this is a special constructor that creates the bean for the specified application
    * with the given 
    */
   public DynamicContext(HttpServletRequest request, HttpServletResponse response,String contextId, String defaultApplication, JavaScriptLoadingIndicator indicator) {
      this.contextId = contextId;
      dynamicContextBean = new DynamicContextBean(request,response,contextId,defaultApplication);
      
      if (dynamicContextBean.getClassName() == null && defaultApplication != null) 
         dynamicContextBean.setClassName(defaultApplication);
      
      this.indicator = indicator;
   }

   @Override
   public String getContextId() {
      return contextId;
   }
   
   @Override
   public String getClassName() {
      return dynamicContextBean.getClassName();
   }
   
   /**
    * 
    * This method will forward
    * 
    *  
    * @param application - the classname of class that extends ApplicationInstance.
    * @return
    */
   public String jsForward(String application) {
      return "w20.context." + getContextId() + ".forward(" + StringUtil.jsQuote(application) + ");";
   }
   
   public void jsDeclareObject(Writer out) throws IOException {
      dynamicContextBean.jsDeclareObject(out);
      
      out.write("function new_" + getContextId() + "() {\n");
      out.write("  obj = {\n");
      // declare common attributes
      super.jsDeclareObject(out);
      out.write("    " + getContextId() + "Bean: new_" + dynamicContextBean.getJavaScriptBeanName() + "(),\n");
      out.write("    forward: function (className ) {\n");
      out.write("      this." + dynamicContextBean.getJavaScriptBeanName() + ".set('" + DynamicContextBean.Attributes.CLASS_NAME + "', className);\n");
      out.write("      this.reload();\n");
      out.write("    }\n");
      out.write("  }\n");
      out.write("  return obj;\n");
      out.write("}\n");
   }
   @Override
   protected JavaScriptLoadingIndicator getJavaScriptLoadingIndicator() {
      return indicator;
   }
   
   public DynamicContextBean getDynamicContextBean() {
      return dynamicContextBean;
   }
   
   
}
