package com.getsnappy.snappyj; 

import java.io.IOException;
import java.io.Writer;

import javax.servlet.http.HttpServletRequest;

/**
 * FIXME: add comments!
 * 
 * @author brian
 *
 */
public abstract class StaticContext extends Context {
   String contextId;
   String className;
   JavaScriptLoadingIndicator indicator;
   

   /**
    * Create a new static context.  Static Contexts are contexts that will call the one
    * and only one ApplicationInstance.
    * 
    * @param className
    * @param contextId
    * @param indicator TODO
    * @param queryString
    */
   public StaticContext(String className, String contextId, JavaScriptLoadingIndicator indicator) {
      this.indicator = indicator;
      this.contextId = contextId;
      this.className = className;
   }

   @Override
   public String getClassName() {
      return className;
   }

   @Override
   public String getContextId() {
      return contextId;
   }
   

   public void jsDeclareObject(Writer out) throws IOException {
      out.write("function new_" + getContextId() + "() {\n");
      out.write("  obj = {\n");
      super.jsDeclareObject(out);
      out.write("    className: '" + getClassName() + "'\n");

      out.write("  }\n");
      out.write("  return obj;\n");
      out.write("}\n");
   }
   

   
   
   @Override
   protected JavaScriptLoadingIndicator getJavaScriptLoadingIndicator() {
      return indicator;
   }

}
